import sys

def extract(source, dest):
    if sys.platform != "darwin":
        print "Extraction function is only available on the Mac."
        return
    import plistlib as plist
    import subprocess as fork
    prefs = fork.Popen(['plutil','-convert','xml1','-o','-',source], stdout=fork.PIPE).communicate()[0]
    prefs = plist.readPlistFromString(prefs)
    data = prefs['Profile.dat']
    profile = file(dest,'wb')
    profile.write(data.data)
    profile.close()
    print "--> Profile extracted to", dest

def store(source, dest):
    if sys.platform != "darwin":
        print "Store function is only available on the Mac."
        return
    import plistlib as plist
    import subprocess as fork
    #print dest
    prefs = fork.Popen(['plutil','-convert','xml1','-o','-',dest], stdout=fork.PIPE).communicate()[0]
    prefs = plist.readPlistFromString(prefs)
    profile = file(source,'rb')
    data = profile.read()
    prefs['Profile.dat'].data = data
    profile.close()
    prefsFile = file(dest,'wb')
    plist.writePlist(prefs,dest)
    print "--> Profile from", source, "has been stored"

def convert(source, dest):
    orig = file(source,'rb')
    new = file(dest,'wb')
    def copy(n):
        new.write(orig.read(n))
    def swap(n):
        temp = orig.read(n)
        temp2 = []
        for c in temp: temp2 += c
        temp2.reverse()
        temp = ''.join(temp2)
        new.write(temp)
    copy(8)   # 000-007 | header or something
    swap(4)   # 008-00B | current map
    swap(4)   # 00C-00F | current song?
    swap(4)   # 010-013 | horizontal pos
    swap(4)   # 014-017 | vertical pos
    swap(4)   # 018-01B | facing direction
    swap(2)   # 01C-01D | max HP
    swap(2)   # 01E-01F | whimsical star
    swap(2)   # 020-021 | Current HP
    copy(2)   # 022-023 | Unused? Possibly alignment filler
    swap(4)   # 024-027 | Current Weapon
    copy(4)   # 028-02B | Unused?
    swap(4)   # 02C-02F | Equipped Items
    copy(4)   # 030-033 | Unused?
    swap(4)   # 034-037 | Time
    swap(4)   # 038-03B | Slot 1 Weapon Type
    swap(4)   # 03C-03F | Slot 1 Weapon Level
    swap(4)   # 040-043 | Slot 1 Weapon Energy
    swap(4)   # 044-047 | Slot 1 Weapon Max Ammo
    swap(4)   # 048-04B | Slot 1 Weapon Current Ammo
    swap(4)   # 04C-04F | Slot 2 Weapon Type
    swap(4)   # 050-053 | Slot 2 Weapon Level
    swap(4)   # 054-057 | Slot 2 Weapon Energy
    swap(4)   # 058-05B | Slot 2 Weapon Max Ammo
    swap(4)   # 05C-05F | Slot 2 Weapon Current Ammo
    swap(4)   # 060-063 | Slot 3 Weapon Type
    swap(4)   # 064-067 | Slot 3 Weapon Level
    swap(4)   # 068-06B | Slot 3 Weapon Energy
    swap(4)   # 06C-06F | Slot 3 Weapon Max Ammo
    swap(4)   # 070-073 | Slot 3 Weapon Current Ammo
    swap(4)   # 074-077 | Slot 4 Weapon Type
    swap(4)   # 078-07B | Slot 4 Weapon Level
    swap(4)   # 07C-07F | Slot 4 Weapon Energy
    swap(4)   # 080-083 | Slot 4 Weapon Max Ammo
    swap(4)   # 084-087 | Slot 4 Weapon Current Ammo
    swap(4)   # 088-08B | Slot 5 Weapon Type
    swap(4)   # 08C-08F | Slot 5 Weapon Level
    swap(4)   # 090-093 | Slot 5 Weapon Energy
    swap(4)   # 094-097 | Slot 5 Weapon Max Ammo
    swap(4)   # 098-09B | Slot 5 Weapon Current Ammo
    swap(4)   # 09C-09F | Slot 6 Weapon Type
    swap(4)   # 0A0-0A3 | Slot 6 Weapon Level
    swap(4)   # 0A4-0A7 | Slot 6 Weapon Energy
    swap(4)   # 0A8-0AB | Slot 6 Weapon Max Ammo
    swap(4)   # 0AC-0AF | Slot 6 Weapon Current Ammo
    swap(4)   # 0B0-0B3 | Slot 7 Weapon Type
    swap(4)   # 0B4-0B7 | Slot 7 Weapon Level
    swap(4)   # 0B8-0BB | Slot 7 Weapon Energy
    swap(4)   # 0BC-0BF | Slot 7 Weapon Max Ammo
    swap(4)   # 0C0-0C3 | Slot 7 Weapon Current Ammo
    swap(4)   # 0C4-0C7 | Slot 8 Weapon Type
    swap(4)   # 0C8-0CB | Slot 8 Weapon Level
    swap(4)   # 0CC-0CF | Slot 8 Weapon Energy
    swap(4)   # 0D0-0D3 | Slot 8 Weapon Max Ammo
    swap(4)   # 0D4-0D7 | Slot 8 Weapon Current Ammo
    swap(4)   # 0D8-0DB | Inventory R1C1
    swap(4)   # 0DC-0DF | Inventory R1C2
    swap(4)   # 0E0-0E3 | Inventory R1C3
    swap(4)   # 0E4-0E7 | Inventory R1C4
    swap(4)   # 0E8-0EB | Inventory R1C5
    swap(4)   # 0EC-0EF | Inventory R1C6
    swap(4)   # 0F0-0F3 | Inventory R2C1
    swap(4)   # 0F4-0F7 | Inventory R2C2
    swap(4)   # 0F8-0FB | Inventory R2C3
    swap(4)   # 0FC-0FF | Inventory R2C4
    swap(4)   # 100-103 | Inventory R2C5
    swap(4)   # 104-107 | Inventory R2C6
    swap(4)   # 108-10B | Inventory R3C1
    swap(4)   # 10C-10F | Inventory R3C2
    swap(4)   # 110-113 | Inventory R3C3
    swap(4)   # 114-117 | Inventory R3C4
    swap(4)   # 118-11B | Inventory R3C5
    swap(4)   # 11C-11F | Inventory R3C6
    swap(4)   # 120-123 | Inventory R4C1
    swap(4)   # 124-127 | Inventory R4C2
    swap(4)   # 128-12B | Inventory R4C3
    swap(4)   # 12C-12F | Inventory R4C4
    swap(4)   # 130-133 | Inventory R4C5
    swap(4)   # 134-137 | Inventory R4C6
    swap(4)   # 138-13B | Inventory R5C1
    swap(4)   # 13C-13F | Inventory R5C2
    swap(4)   # 140-143 | Inventory R5C3
    swap(4)   # 144-147 | Inventory R5C4
    swap(4)   # 148-14B | Inventory R5C5
    swap(4)   # 14C-14F | Inventory R5C6
    swap(4)   # 150-153 | Inventory R6C1
    swap(4)   # 154-157 | Inventory R6C2
    swap(4)   # 158-15B | Slot 1 Teleporter Menu
    swap(4)   # 15C-15F | Slot 1 Teleporter Location
    swap(4)   # 160-163 | Slot 2 Teleporter Menu
    swap(4)   # 164-167 | Slot 2 Teleporter Location
    swap(4)   # 168-16B | Slot 3 Teleporter Menu
    swap(4)   # 16C-16F | Slot 3 Teleporter Location
    swap(4)   # 170-173 | Slot 4 Teleporter Menu
    swap(4)   # 174-177 | Slot 4 Teleporter Location
    swap(4)   # 178-17B | Slot 5 Teleporter Menu
    swap(4)   # 17C-17F | Slot 5 Teleporter Location
    swap(4)   # 180-183 | Slot 6 Teleporter Menu
    swap(4)   # 184-187 | Slot 6 Teleporter Location
    swap(4)   # 188-18B | Slot 7 Teleporter Menu
    swap(4)   # 18C-18F | Slot 7 Teleporter Location
    swap(4)   # 190-193 | Slot 8 Teleporter Menu
    swap(4)   # 194-197 | Slot 8 Teleporter Location
    copy(128) # 198-217 | Unused?
    copy(4)   # 218-21B | "FLAG"
    copy(232) # 21C-303 | Flags - don't swap
    # And the remainder of the file:
    new.write(orig.read())
    orig.close()
    new.close()
    print "--> Profile converted."