import sys
import os

from csc_util import *
from csc_strings import *

def deleteTemp(fileName):
	print strings['confirmRemoveTemp'] % fileName
	if raw_input().upper() == 'Y':
		os.remove(fileName)
		print strings['removedTemp']

def wclipenergy(weapon,level,energy):
	maxenergy = {1:{1:30,2:40,3:16}, 2:{1:10,2:20,3:10}, 3:{1:10,2:20,3:20},
				 4:{1:30,2:40,3:10}, 5:{1:10,2:20,3:10}, 7:{1:10,2:20,3:5},
				 9:{1:30,2:60,3:0}, 10:{1:30,2:60,3:10}, 12:{1:1,2:1,3:1}}
	if weapon == 13: return 0;
	elif energy > maxenergy[weapon][level]:
		return maxenergy[weapon][level]
	else: return energy

def wadd(weapon, power, ammo, dest):
	"""Add a weapon to the player's inventory."""
	#maxenergy = [None, 16, 10, 20, 10, 10, None, 5, None, 0, 10, None, 1, 0]
	defammo = {1:0, 2:0, 3:0, 4:100, 5:100, 7:50, 9:0, 10:100, 12:0, 13:0}
	# Step 1: parse weapon. Format: either a name or an ID.
	try:
		weapon = int(weapon)
		if weapon > 13 or weapon in (0,6,8,11) or weapon < 0:
			print strings['badWeaponID'] % weapon
			return
	except:
		try:
			weapon = wnames[weapon]
		except:
			print strings['badWeaponName'] % weapon
			return
	# Step 2: parse power. Format: "level" or "level(energy)" or "MAX"
	level = 0
	energy = 0
	try:
		if '[' in power and ']' in power:
			tmp = power.split('[')
			if tmp[1][-1] != ']' or ']' in tmp[0]:
				raise TypeError # is this really the right exception here?
			level = int(tmp[0])
			energy = int(tmp[1][:-1])
		elif power.upper() == "MAX":
			level = 4
			energy = 100 # greater than any maximum, so clipping is guaranteed
		else:
			level = int(power)
			energy = 0
	except:
		print strings['badWeaponPower'] % power
		return
	energy = wclipenergy(weapon,level,energy)
	# Step 3: parse ammo. Format: "ammo" or "ammo/max"
	maxammo = 0
	try:
		if '/' in ammo:
			tmp = ammo.split('/')
			maxammo = int(tmp[1])
			ammo = int(tmp[0])
		elif ammo == "def" or ammo == "default":
			maxammo = defammo[weapon]
			ammo = maxammo
		else:
			ammo = int(ammo)
			maxammo = -1
	except:
		print strings['badWeaponAmmo'] % ammo
		return
	# Step 4: Validate ammo and level
	# Only weapons 4, 5, 7, and 10 are allowed ammo.
	# Weapon 13 is allowed neither ammo nor level.
	if maxammo > 0 and weapon not in (4,5,7,10):
		print strings['weaponNoAmmo']
		ammo = 0
		maxammo = 0
	if weapon == 13 and level > 1:
		print strings['spurNoLevel']
		level = 1
	#if power[0] == 'L' or power[0] == 'l':
	#	level = power[1:]
	#	level = int(level)
	#	energy = -1 # means "calculate later"
	#elif power.upper() == "MAX":
	#	level = 4
	#else:
	#	energy = int(power)
	#	level = -1 # means "calculate later"
	#if energy == -1:
	#	energy = wlvl2energy(level,weapon)
	#elif level == -1:
	#	level = wenergy2lvl(energy,weapon)
	if level > 4 or level < 1:
		print strings['badWeaponLevel']
		return
	profile = open(dest,'r+b')
	curoffset = 0x38
	done = False
	while not done:
		if curoffset >= 0xC4:
			print strings['weaponsFull']
			return
		profile.seek(curoffset)
		curtype = profile.read(1)
		if curtype == '\0':
			done = True
		elif curtype == chr(weapon):
			print strings['weaponPresent'] % weapon
			done = True
		else:
			curoffset += 20
	if maxammo == -1: # If max ammo wasn't specified, try finding it.
		profile.seek(curoffset+12)
		maxammo = numFromLittleEndian(profile.read(4))
		if maxammo == 0: maxammo = defammo[weapon]
	print strings['addingWeapon'] % (weapon, "MAX" if level == 4 else `level`, energy, `ammo` + '/' + `maxammo` if ammo != maxammo else `ammo`)
	#print "--> Adding weapon", weapon, 'at level', "MAX" if level == 4 else `level, 'with', energy, 'energy and', `ammo` + '/' + `maxammo` if ammo != maxammo else ammo, "ammo."
	if level == 4: level = 3
	profile.seek(curoffset)
	profile.write(numToLittleEndian(weapon,4))
	profile.seek(curoffset+4)
	profile.write(numToLittleEndian(level,4))
	profile.seek(curoffset+8)
	profile.write(numToLittleEndian(energy,4))
	profile.seek(curoffset+12)
	profile.write(numToLittleEndian(maxammo,4))
	profile.seek(curoffset+16)
	profile.write(numToLittleEndian(ammo,4))
	profile.close()

def wequip(weapon, dest):
	try:
		weapon = int(weapon)
		if weapon > 13 or weapon in (0,6,8,11) or weapon < 0:
			print strings['badWeaponID'] % weapon
			return
	except:
		try:
			weapon = wnames[weapon]
		except:
			print strings['badWeaponName'] % weapon
			return
	profile = open(dest,'r+b')
	# Find the weapon
	curoffset = 0x38
	slot = 0
	done = False
	while not done:
		if curoffset >= 0xC4:
			print strings['lackWeapon'] % weapon
			return
		profile.seek(curoffset)
		curtype = profile.read(1)
		if curtype == '\0':
			print strings['lackWeapon'] % weapon
			return
		elif curtype == chr(weapon):
			print strings['equipWeapon'] % weapon
			done = True
		else:
			curoffset += 20
			slot += 1
	profile.seek(0x24)
	profile.write(numToLittleEndian(slot,4))

def wrem(weapon, dest):
	"""Remove a weapon from the player's inventory, and shift existing weapons down."""
	profile = open(dest,'r+b')
	try:
		weapon = int(weapon)
		if weapon > 13 or weapon in (0,6,8,11) or weapon < 0:
			print strings['badWeaponID'] % weapon
			return
	except:
		try:
			weapon = wnames[weapon]
		except:
			if weapon == "all":
				print strings['disarming']
				profile.seek(0x38)
				profile.write('\0' * 160)
				profile.seek(0x24) # Set active weapon to 0
				profile.write(numToLittleEndian(0,4))
				profile.close()
			else:
				print strings['badWeaponName'] % weapon
			return
	curoffset = 0x38
	found = False
	while curoffset <= 0xC4:
		if found:
			profile.seek(curoffset)
			next = profile.read(20)
			profile.seek(curoffset-20)
			profile.write(next)
		else:
			profile.seek(curoffset)
			curtype = profile.read(1)
			if curtype == chr(weapon): found = True
		curoffset += 20
	profile.seek(0xC4)
	profile.write('\0' * 20)
	if not found:
		print strings['weaponNotFound']
	else:
		print strings['takingWeapon'] % weapon
	profile.close()

def iadd(item, dest):
	"""Add an item to the player's inventory."""
	if item > 255:
		print strings['badItemID'] % item
		return
	profile = open(dest,'r+b')
	curoffset = 0xD8
	done = False
	while not done:
		if curoffset >= 0x154:
			print strings['itemsFull']
			return
		profile.seek(curoffset)
		curtype = profile.read(1)
		if curtype == '\0':
			done = True
		elif curtype == chr(item):
			print strings['itemPresent'] % item
			return
		else:
			curoffset += 4
	print strings['addingItem'] % item
	profile.seek(curoffset)
	profile.write(numToLittleEndian(item,4))
	profile.close()

def iequip(item, equip, dest):
	"""Equip an item, which may or may not be in the player's inventory."""
	if item not in (1,2,4,8,16,32,64,128,256):
		print strings['badEquipID'] % item
		return
	profile = open(dest,'r+b')
	profile.seek(0x2C)
	flags = numFromLittleEndian(profile.read(4))
	if equip:
		flags |= item
	else:
		flags &= ~item
	profile.seek(0x2C)
	profile.write(numToLittleEndian(flags,4))
	print strings['equippedItem'] % (item,"" if equip else "un")

def irem(item, dest):
	"""Remove an item from the player's inventory, and shift existing items down."""
	profile = open(dest,'r+b')
	curoffset = 0xD8
	found = False
	while curoffset <= 0x154:
		if found:
			profile.seek(curoffset)
			next = profile.read(4)
			profile.seek(curoffset-4)
			profile.write(next)
		else:
			profile.seek(curoffset)
			curtype = profile.read(1)
			if curtype == chr(item): found = True
		curoffset += 4
	profile.seek(0x154)
	profile.write('\0' * 4)
	if not found:
		print strings['itemNotFound'] % item
	else:
		print strings['takingItem'] % item
	profile.close()

def fset(flag, dest):
	# TODO: implement set flag
	print "(not implemented)"
	# print strings['setFlag'] % flag

def fclear(flag, dest):
	# TODO: implement clear flag
	print "(not implemented)"
	# print strings['clearFlag'] % flag

def edit(attrs, dest):
	notImplemented = None
	profile = open(dest, 'r+b')
	def writeAt(what,where):
		profile.seek(where)
		profile.write(what)
	if attrs.has_key('maxhp'):
		if attrs['maxhp'] == 'max':
			attrs['maxhp'] = 256
		elif attrs['maxhp'] > 232:
			print strings['healthFull']
		else:
			writeAt(numToLittleEndian(attrs['maxhp'],2),0x1C)
	if attrs.has_key('hp'):
		max = 0
		if attrs.has_key('maxhp'):
			max = attrs['maxhp']
		else:
			profile.seek(0x1C)
			attrs['hp'] = numFromLittleEndian(profile.read(2))
		if attrs['hp'] == 'max':
			attrs['hp'] = max
		if attrs['hp'] > max:
			print strings['healthFull']
		else:
			writeAt(numToLittleEndian(attrs['hp']),0x20)
	if attrs.has_key('map'):
		writeAt(numToLittleEndian(attrs['map'],4),0x08)
	if attrs.has_key('song'):
		writeAt(numToLittleEndian(attrs['song'],4),0x0C)
	if attrs.has_key('horz'):
		pos = float(attrs['horz'])
		pos *= 32
		pos = int(pos)
		writeAt(numToLittleEndian(pos,2),0x11)
	if attrs.has_key('vert'):
		pos = float(attrs['vert'])
		pos *= 32
		pos = int(pos)
		writeAt(numToLittleEndian(pos,2),0x15)
	if attrs.has_key('dir'):
		if attrs['dir'] == 'L' or attrs['dir'] == 'l':
			writeAt(numToLittleEndian(0,4),0x18)
		elif attrs['dir'] == 'R' or attrs['dir'] == 'r':
			writeAt(numToLittleEndian(2,4),0x18)
		else:
			print strings['badDirection']
	if attrs.has_key('star'):
		writeAt(numToLittleEndian(attrs['star'],2),0x1E)
	if attrs.has_key('time'):
		writeAt(numToLittleEndian(attrs['star'],2),0x34)
	# TODO: implement these other attributes
	# 022-023 | Unused? Possibly alignment filler
	# 028-02B | Unused?
	# 030-033 | Unused?

def trem(icon,dest):
	"""Remove a teleporter location, and shift existing ones down."""
	try:
		icon = int(icon)
	except:
		if ticonnames.has_key(icon):
			icon = ticonnames[icon]
		else:
			print strings['badWarp'] % icon
			return
	profile = open(dest,'r+b')
	curoffset = 0x158
	found = False
	while curoffset <= 0x190:
		if found:
			profile.seek(curoffset)
			next = profile.read(8)
			profile.seek(curoffset-8)
			profile.write(next)
		else:
			profile.seek(curoffset)
			curtype = profile.read(1)
			if curtype == chr(icon): found = True
		curoffset += 8
	profile.seek(0x194)
	profile.write('\0' * 8)
	if not found:
		print strings['warpNotFound'] % icon
	else:
		print strings['takingWarp'] % icon
	profile.close()

#Teleporter destinations
#136  Egg Corridor
#137  Grasstown
#138  Sand Zone
#139  Labyrinth
#140  Plantation

def tadd(icon,loc,dest):
	"""Add a teleport location to the main teleporter."""
	try:
		icon = int(icon)
	except:
		if ticonnames.has_key(icon):
			icon = ticonnames[icon]
		else:
			print strings['badWarp'] % icon
			return
	try:
		loc = int(loc)
	except:
		print strings['badWarpEvent'] % loc
		return
	#if loc > 5 or loc < 1:
	#	print "Invalid teleporter location."
	#	return
	profile = open(dest,'r+b')
	curoffset = 0x158
	done = False
	while not done:
		if curoffset >= 0x194:
			print strings['warpFull']
			return
		profile.seek(curoffset)
		curtype = profile.read(1)
		if curtype == '\0':
			done = True
		elif curtype == chr(icon):
			print strings['warpPresent'] % icon
			done = True
		else:
			curoffset += 8
	print strings['addingWarp'] % (icon,loc)
	profile.seek(curoffset)
	profile.write(numToLittleEndian(icon,4))
	profile.seek(curoffset+4)
	profile.write(numToLittleEndian(loc,4))
	profile.close()

def move(horz,vert,file):
	horz = int(float(horz) * 32)
	vert = int(float(vert) * 32)
	profile = open(file,'r+b')
	print strings['moving'] % (horz,vert)
	profile.seek(0x11)
	horz += numFromLittleEndian(profile.read(2))
	profile.seek(0x11)
	profile.write(numToLittleEndian(horz,2))
	profile.seek(0x15)
	vert += numFromLittleEndian(profile.read(2))
	profile.seek(0x15)
	profile.write(numToLittleEndian(vert,2))
	profile.close()
