import sys
import os
from csc_util import *
from csc_strings import *
from csc_globals import *

def getUserInput(tasks):
	"""Get user input"""
	if sys.platform == 'darwin':
		print menus['macMain']
		input = readChar().upper()
		if input == responses['extract']:
			source = getPL()
			dest = chooseFile(strings['getDest'],False)
			if dest != "" and source != "":
				tasks.append( ("extract-mac-profile",source,".pycs_temp") )
				tasks.append( ("convert-profile",".pycs_temp",dest) )
				tasks.append( ("clean-temp-file",".pycs_temp") )
				tasks.append( ("interactive",) )
		elif input == responses['store']:
			source = chooseFile(strings['getSource'],True)
			dest = getPL()
			if dest != "" and source != "":
				tasks.append( ("convert-profile",source,".pycs_temp") )
				tasks.append( ("store-mac-profile",".pycs_temp",dest) )
				tasks.append( ("clean-temp-file",".pycs_temp") )
				tasks.append( ("interactive",) )
		elif input == responses['edit']:
			tasks.append( ("choose-file",) )
			tasks.append( ("advanced-interactive",) )
		elif input != responses['quit']:
			print strings['wrong']
			tasks.append( ("interactive",) )
	else:
		tasks.append( ("choose-file",) )
		tasks.append( ("advanced-interactive",) )

def interactiveEditMode(tasks):
	global curFile
	print menus['main']
	input = readChar().upper()
	if input == responses['weapon']:
		interactiveWeapon(tasks)
	elif input == responses['open']:
		tasks.append( ("choose-file",) )
		tasks.append( ("advanced-interactive",) )
	elif input == responses['bkup']:
		tasks.append( ("backup",curFile) )
		tasks.append( ("advanced-interactive",) )
	elif input == responses['item']:
		interactiveItem(tasks)
	elif input == responses['advanced']:
		interactiveAttr(tasks)
	elif input == responses['warp']:
		interactiveWarp(tasks)
	elif input == responses['move']:
		task = ("move",)
		print strings['moveHorz']
		task += (readReal(),)
		print strings['moveVert']
		task += (readReal(),)
		task += (curFile,)
		tasks.append(task)
		tasks.append( ("advanced-interactive",) )
	elif input == responses['view']:
		tasks.append( ("interactive-view",) )
	elif input == responses['flag']:
		interactiveFlag(tasks)
	elif input == responses['stage']:
		interactiveStage(tasks)
	elif input == responses['quit']:
		if sys.platform == "darwin": tasks.append( ("interactive",) )

def chooseFile(prompt,mustExist):
	file = ""
	while True:
		print prompt
		input = readLine()
		if input.upper() == 'Q':
			break
		elif mustExist and not os.path.exists(input):
			print strings['notFound'] % input
			continue
		else:
			file = input
			break
	return file

def getPL():
	file = ""
	if sys.platform == "darwin":
		if not os.path.exists(defPLPath):
			print strings['noPrefs']
		else:
			file = defPLPath
	else:
		print strings['notMac']
	return file

def chooseMainFile():
	global curFile
	curFile = chooseFile(strings['editWhich'],True)

def interactiveWeapon(tasks):
	print strings['addRemoveEquip']
	readWeapon = lambda: readArg( *(wnames.keys() + [int]) )
	input = readChar().upper()
	if input == responses['add']:
		task = ("add-weapon",)
		print strings['whichWeapon']
		task += (readWeapon(),)
		print strings['power']
		task += (readLine(),)
		print strings['ammo']
		task += (readLine(),)
		task += (curFile,)
		tasks.append(task)
	elif input == responses['remove']:
		task = ("remove-weapon",)
		print strings['whichWeapon']
		task += (readWeapon(),)
		task += (curFile,)
		tasks.append(task)
	elif input == responses['equip']:
		task = ("equip-weapon",)
		print strings['whichWeapon']
		task += (readWeapon(),)
		task += (curFile,)
		tasks.append(task)
	else:
		print strings['wrong']
	tasks.append( ("advanced-interactive",) )

def interactiveItem(tasks):
	print strings['addRemoveEquip']
	input = readChar().upper()
	if input == responses['add']:
		task = ("add-item",)
		print strings['whichItem']
		task += (readNum(),)
		task += (curFile,)
		tasks.append(task)
	elif input == responses['remove']:
		task = ("remove-item",)
		print strings['whichItem']
		task += (readNum(),)
		task += (curFile,)
		tasks.append(task)
	elif input == responses['equip']:
		task = ("equip-item",)
		print strings['whichItem']
		task += (readNum(),)
		print strings['equip?']
		input = readChar().upper()
		if input == responses['yes']:
			task += (True,)
		elif input == responses['no']:
			task += (False,)
		else:
			print strings['wrong']
			task += (None,)
		task += (curFile,)
		tasks.append(task)
	else:
		print strings['wrong']
	tasks.append( ("advanced-interactive",) )

def interactiveAttr(tasks):
	attrs = {}
	input = ''
	while input != responses['quit']:
		print menus['attr']
		input = readChar().upper()
		if input == responses['hp']:
			print strings['getHealth']
			attrs['hp'] = readArg('max',(0,232))
		elif input == responses['maxhp']:
			print strings['getLife']
			attrs['maxhp'] = readArg('max',(0,232))
		elif input == responses['map']:
			print strings['whichMap']
			attrs['map'] = readNum()
		elif input == responses['song']:
			print strings['whichSong']
			attrs['song'] = readNum()
		elif input == responses['horz']:
			print strings['whereHorz']
			attrs['horz'] = readReal()
		elif input == responses['vert']:
			print strings['whereVert']
			attrs['vert'] = readReal()
		elif input == responses['dir']:
			print strings['whichDir']
			attrs['dir'] = readArg('L','R')
		elif input == responses['star']:
			print strings['starCount']
			attrs['star'] = readNum()
		elif input == responses['time']:
			print "Number"
			attrs['time'] = readNum()
		else:
			print strings['wrong']
	for x in attrs.keys():
		if attrs[x] == None: del attr[x]
	if attrs != {}:
		tasks.append( ("advanced-edit", attrs, curFile) )
	tasks.append( ("advanced-interactive",) )

def interactiveWarp(tasks):
	print strings['addRemove']
	input = readChar().upper()
	if input == responses['add']:
		task = ("add-teleporter",)
		print strings['whichIcon']
		task += (readNum(),)
		print strings['whichWarp']
		task += (readNum(),)
		task += (curFile,)
		tasks.append(task)
	elif input == responses['remove']:
		task = ("remove-teleporter",)
		print strings['whichIcon']
		task += (readNum(),)
		task += (curFile,)
		tasks.append(task)
	else:
		print strings['wrong']
	tasks.append( ("advanced-interactive",) )

def interactiveView(tasks):
	input = ''
	print menus['view']
	task = ("view",)
	input = readChar().upper()
	if input == responses['basic']:
		task += ('b',)
	elif input == responses['weapon']:
		task += ('w',)
	elif input == responses['item']:
		task += ('i',)
	elif input == responses['warp']:
		task += ('t',)
	elif input == responses['flag']:
		task += ('f',)
	elif input == responses['stage']:
		print "(not implemented)"
		#task += ('m',)
	elif input != responses['quit']:
		print strings['wrong']
	else:
		tasks.append( ("advanced-interactive",) )
		return
	task += (curFile,)
	if(len(task) == 3): tasks.append(task)
	tasks.append( ("interactive-view",) )

def interactiveFlag(tasks):
	print strings['whichFlag']
	flag = readRange(0,7999)
	if flag != None:
		print strings['setFlag?']
		input = readChar().upper()
		if input == responses['yes']:
			tasks.append( ('set-flag', flag, curFile) )
		elif input == responses['no']:
			tasks.append( ('unset-flag', flag, curFile) )
		elif input != responses['quit']:
			print strings['wrong']
	tasks.append( ("advanced-interactive",) )

def interactiveStage(tasks):
	print "(not implemented)"
	tasks.append( ("advanced-interactive",) )