
class menuItem:
	def __init__(self,k,t):
		self.key = k
		self.title = t
	
	def __str__(self):
		return self.key + ' - ' + self.title

class menu:
	def __init__(self,prompt,note=""):
		self.top = prompt
		self.bottom = note
		self.choices = []
	
	def __str__(self):
		ret = ""
		ret += self.top + '\n'
		for x in self.choices:
			ret += str(x) + '\n'
		if self.bottom != "": ret += self.bottom + '\n'
		return ret
	
	def add(self,key,title):
		self.choices += [menuItem(key,title)]
		return self

responses = {
	# Main menu responses
	'extract':'E',
	'store':'S',
	'edit':'X',
	# Editing responses
	'weapon':'W',
	'open':'O',
	'bkup':'B',
	'item':'I',
	'advanced':'X',
	'warp':'T', # T for teleport
	'move':'M',
	'view':'V',
	'flag':'F',
	'stage':'S',
	# View responses (plus weapon, warp, flag, stage)
	'basic':'B',
	# Advanced editing responses
	'hp':'D', # D for damage
	'maxhp':'L', # L for life
	'map':'M',
	'song':'S',
	'horz':'H',
	'vert':'V',
	'dir':'F', # F for facing
	'star':'W', # W for whimsical
	'time':'T',
	# Basic responses
	'quit':'Q',
	'add':'A',
	'remove':'R',
	'equip':'E',
	'yes':'Y',
	'no':'N'
}

menus = {
	'macMain': menu("Which operation would you like to perform?")
		.add(responses['extract'],"Extract a save from a Macintosh property list and save it to a file.")
		.add(responses['store'],"Store a save in a Macintosh property list, overwriting the existing one.")
		.add(responses['edit'],"Edit a save file.")
		.add(responses['quit'],"Quit the program."),
	'main': menu("What would you like to do?",
		"Note: Editing is not undoable!")
		.add(responses['open'],"Select another file.")
		.add(responses['bkup'],"Backup current file.")
		.add(responses['weapon'],"Edit weapons")
		.add(responses['item'],"Edit inventory")
		.add(responses['warp'],"Edit teleporter")
		.add(responses['flag'],"Edit event flags (not implemented)")
		.add(responses['stage'],"Edit map flags (not implemented)")
		.add(responses['advanced'],"Edit other attributes")
		.add(responses['move'],"Move player")
		.add(responses['view'],"View save file")
		.add(responses['quit'],"Finish editing."),
	'view': menu("View which part?")
		.add(responses['basic'],"Basic information")
		.add(responses['weapon'],"Weapons")
		.add(responses['item'],"Items")
		.add(responses['warp'],"Teleporter")
		.add(responses['flag'],"Event flags (doesn't work)")
		.add(responses['stage'],"Map flags (not implemented)")
		.add(responses['quit'],"Return to editing."),
	'attr': menu("Edit which attribute?")
		.add(responses['hp'],"Health")
		.add(responses['maxhp'],"Max health")
		.add(responses['map'],"Map")
		.add(responses['song'],"Song")
		.add(responses['horz'],"Horizontal position")
		.add(responses['vert'],"Vertical position")
		.add(responses['dir'],"Facing direction")
		.add(responses['star'],"Whimsical Star")
		.add(responses['time'],"Time???")
		.add(responses['quit'],"Edit something else.")
}

#menus = {
#	'macMain':"""Which operation would you like to perform?
#E - Extract a save from a Macintosh property list and save it to a file.
#S - Store a save in a Macintosh property list, overwriting the existing one.
#X - Edit a save file.
#Q - Quit the program.""",
#	'main':"""What would you like to do?"
#O - Select another file.
#B - Backup current file.
#W - Edit weapons
#I - Edit inventory
#T - Edit teleporter
#F - Edit flags (not implemented)
#X - Edit other attributes
#M - Move player
#V - View save file
#Q - Finish editing.
#Note: Editing is not undoable!""",
#	'view':"""View which part?
#B - Basic information
#W - Weapons
#I - Items
#T - Teleporter
#F - Flags (doesn't work)
#Q - Return to editing.""",
#	'attr':"""Edit which attribute?
#H - Health
#L - Max health
#M - Map
#S - Song
#H - Horizontal position
#V - Vertical position
#D - Facing direction
#W - Whimsical Star
#T - Time???""",
#}

strings = {
	'noPrefs':"""Sorry, but the prefs file cannot be found.
Perhaps Cave Story has not been installed or run on this account.""",
	'notMac':"Sorry, the default path is only available on the Mac.",
	'getSource':"""Enter the filename of the profile to store:
Or type Q to cancel.""",
	'getDest':"""Enter the filename to extract the profile to:
Or type Q to cancel.""",
	'addRemove':"Add or remove (A/R)?",
	'addRemoveEquip':"Add, remove, or equip (A/R/E)?",
	'whichWeapon':"Which weapon?",
	'power':"At what power?",
	'ammo':"Ammo?",
	'wrong':"Invalid response.",
	'whichItem':"Which item?",
	'equip?':"Equip the item (Y/N)?",
	'notFound':"File %s not found.",
	'editWhich':"Which file would you like to edit?",
	'getHealth':"Enter a number from 0 to 232, or max to fill your health bar.",
	'getLife':"Enter a number from 0 to 232, or max for maximum possible health.",
	'whichFlag':"Which flag do you want to change?",
	'setFlag?':"Would you like the flag to be set (Y/N)?",
	'getMap':"Move to which map?",
	'whichSong':"Which song?",
	'whereHorz':"How many tiles from the left edge?",
	'whereVert':"How many tiles from the top edge?",
	'whichDir':"Which direction (L/R)?",
	'starCount':"How many whimsical stars?",
	'moveHorz':"How far to move horizontally (right is positive)?",
	'moveVert':"How far to move vertically (down is positive)?",
	'whichIcon':"Which teleporter icon?",
	'whichWarp':"Warp to which event?",
	# csc_edit.py
	'confirmRemoveTemp':"Removing temporary file %s, please confirm (Y/N).",
	'removedTemp':"--> Temporary file removed.",
	'badWeaponID':"Invalid weapon ID %d.",
	'badWeaponName':"Invalid weapon name %s.",
	'badWeaponPower':"Invalid weapon power %s.",
	'badWeaponAmmo':"Invalid ammo specification %s.",
	'weaponNoAmmo':"Ammo specified for a weapon that does not have ammo;\nthis has been ignored.",
	'spurNoLevel':"Level specified for the spur; this has been ignored.",
	'badWeaponLevel':"Invalid weapon level.",
	'weaponsFull':"Sorry, no more weapons can be added.",
	'weaponPresent':"--> Weapon %d is already present. Its attributes will be updated.",
	'addingWeapon':"--> Adding weapon %d at level %s with %d energy and %s ammo.",
	'lackWeapon':"Sorry, weapon %d is not in your possession.",
	'equipWeapon':"--> Weapon %d equipped.",
	'disarming':"--> All weapons removed.",
	'weaponNotFound':"The weapon wasn't found; the profile has not been altered.",
	'takingWeapon':"--> Weapon %d removed.",
	'badItemID':"Invalid item ID %d.",
	'itemsFull':"Sorry, no more items can be added.",
	'itemPresent':"--> Item %d is already present.",
	'addingItem':"--> Adding item %d.",
	'badEquipID':"Invalid equippable item %d.",
	'equippedItem':"--> Item %d %sequipped.",
	'itemNotFound':"The item %d wasn't found; the profile has not been altered.",
	'takingItem':"--> Removing item %d.",
	'healthFull':"Too much health.",
	'badDirection':"Invalid direction (should be L or R).",
	'badWarp':"Invalid teleporter icon %s.",
	'warpNotFound':"The location %d wasn't found; the profile has not been altered.",
	'takingWarp':"--> Removing teleporter location %d.",
	'badWarpEvent':"Invalid event %s specified.",
	'warpFull':"Sorry, no more teleporter locations can be added.",
	'warpPresent':"--> Teleporter location %d is already present. Its target will be updated.",
	'addingWarp':"--> Adding teleporter location %d, warping to even %d.",
	'moving':"--> Moving %d spaces right and %d spaces down.",
	'setFlag':"Flag %d set.", 'clearFlag':"Flag %d cleared.",
}

# Map weapon names to weapon IDs
wnames = {"snake":1, "polar":2, "star":2, "polarstar":2, "ps":2,
		  "fire":3, "fireball":3, "fb":3, "machine":4, "machinegun":4, "mg":4,
		  "missile":5, "missilelauncher":5, "ml":5, "bubbler":7, "blade":9,
		  "super":10, "supermissile":10, "supermissilelauncher":10, "superlauncher":10,
		  "sm":10, "sl":10, "sml":10, "nemesis":12, "spur":13}

# Map teleporter icon names to teleporter icon IDs
ticonnames = {"egg":1, "grass":2, "skull":3, "bug":4, "plant":5}

def showVersion():
	print "Cave Story Save Converter"
	print "Version 0.3 beta"
	print "Created by Celtic Minstrel"

def displayUsage(name,platform):
	print "Usage:", name, "[opt [params]]*"
	print
	print "Available options are -e, -s, -c, -w, +w, -i, +i, -f, +f, -x:"
	print "(b|d)%file"
	print "    Specifies the file to work on, overriding any precious"
	print "    occurences of this option. If b is specified, the file"
	print "    will be backed up; if d is specified, it won't be."
	if platform == 'darwin':
		print "-e prefFile"
		print "    Extracts a profile from the Mac property list into a file."
		print "    Use @ for the prefFile to indicate the default property list."
		print "-s prefFile"
		print "    Stores a profile in the Mac property list, replacing the one already there."
		print "    Use @ to for the prefFile indicate the default property list."
	print "+wx@v=z"
	print "    Adds weapon x at power v to your inventory with z ammo. Specify"
	print "    -hw or -?w on the command line for more info."
	print "-wx"
	print "    Removes weapon x from your inventory."
	print "*wx"
	print "    Equips weapon x if it is in your inventory."
	print "+ix"
	print "    Adds item x to your inventory."
	print "-ix"
	print "    Removes item x from your inventory."
	print "*ix"
	print "    Equips item x. Note that the list of equippable items is distinct"
	print "    from the list of regular items (though there is some correspondence"
	print "    between them). x should be a power of 2."
	print "+tx@y"
	print "    Adds teleporter icon x to the warp menu, jumping to event y. If"
	print "    editing a save file of the original game, y should be 6000 + x."
	print "    Instead of a number, you can use one of the following names:"
	print "    egg  grass  skull  bug  plant"
	print "-tx"
	print "    Removes teleporter icon x from the warp menu."
	print "    The special names are valid here too."
	print "+fx"
	print "    Sets flag x. [not implemented yet]"
	print "-fx"
	print "    Unsets flag x. [not implemented yet]"
	print "-mx,y"
	print "    Moves Quote x tiles to the right and y tiles down. If x or y"
	print "    is negative, the direction is reversed."
	print "-x"
	print "    Advanced editing. For more information on advanced edits, specify"
	print "    -hx or -?x in the command line."
	print "-v[parts]"
	print "    View a printout of the contents of the save file. If parts are left"
	print "    unspecified, it is equivalent to specifying all parts. Valid parts"
	print "    are b (basic), w (weapons), i (items), t (teleporter), f (flags)."
	print "    Invalid parts will simply be ignored without an error message."
	print "    [Note: flag display does not work properly in the current version.]"
	print "-h"
	print "    Show this help and exit."
	print "--version"
	print "    Show the current version and exit."
	print ""
	
def advancedHelp():
	print "The syntax for advanced edits is:"
	print "    -x [param=value]* -"
	print "There may be any number of param/value pairs."
	print "Valid parameters are:"
	print "    hp"
	print "        Must be either a number or the keyword 'max'. If it is a number,"
	print "        it sets the current health to that number (even if it's greater"
	print "        than the maximum health). If it is the keyword 'max' (without"
	print "        the quotes), it sets the current health to the maximum. If the"
	print "        maximum health is being set at the same time, the new maximum"
	print "        is used."
	print "    maxhp"
	print "        Must be a number. Sets the maximum health to that number."
	print "        If max is specified instead of a number, sets max health to"
	print "        the maximum possible value. If you do this, don't ever pick"
	print "        up life capsules, since it will decrease your max health."
	print "    map"
	print "        The number of the map Quote is on."
	print "    song"
	print "        The number of the currently playing song."
	print "    horz"
	print "        Quote's horizontal position in the level, measured in tiles"
	print "        from the left edge of the level. This parameter accepts"
	print "        real numbers."
	print "    vert"
	print "        Quote's vertical position in the level, measured fin tiles"
	print "        from the top edge of the level. This parameter accepts"
	print "        real numbers."
	print "    dir"
	print "        Quote's facing direction - either L (left) or R (right)."
	print "    star"
	print "        Number of whimsical stars active; usually 0-3, though more"
	print "        is possible."
	print "    time"
	print "        [unsure]"
	print ""

def weaponHelp():
	#print "Dealing with Weapons"
	#print "===================="
	print "+wx[@y[[z]]][=u[/v]]"
	print "    Adds weapon x at level y to your inventory with z experience"
	print "    and u out of v ammo."
	print "    weapon (x)"
	print "        A weapon name or ID (see below)"
	print "    level (y)"
	print "        The weapon level (an integer from 1 to 3); defaults to 1"
	print "        A level specified for the spur will be ignored."
	print "        The level may also be specified as MAX, in which case"
	print "        the energy must be omitted."
	print "    energy (z)"
	print "        Weapon energy level. Each weapon/level combination"
	print "        has its own maximum energy; if a too large value"
	print "        is specified, the maximum will be used."
	print "        Defaults to 0."
	print "    ammo (u)"
	print "        The current ammo in the weapon. Keep in mind that the"
	print "        bubbler and machine gun automatically recharge as soon"
	print "        as they are equipped. If specified as anything other than"
	print "        zero for a weapon without ammo, it will be ignored."
	print "        Defaults to the same as the max ammo."
	print "    max (v)"
	print "        The maximum ammo the weapon can hold. Defaults to 100"
	print "        for missiles, super missiles, and machine gun, 50 for"
	print "        bubbler, and zero for anything else."
	print "-wx"
	print "    Removes weapon x from your inventory."
	print "-wall"
	print "    Removes all weapons from your inventory."
	print "*wq"
	print "    Equips weapon q."
	print ""
	print "Valid weapons"
	print "-------------"
	print "1   2   3   4   5   7   9   10   12   13"
	print "snake polar star polarstar fire fireball"
	print "machine machinegun missile missilelauncher"
	print "bubbler blade super supermissile superlauncher"
	print "supermissilelauncher nemesis spur"
	print "ps fb mg ml sm sl sml"
	print ""