import sys

def numToLittleEndian(n, numbytes):
    i = 0
    string = ""
    while n > 0:
        string += chr(n%256)
        n /= 256
        n = int(n) # Because I'm not sure if integer division automatically truncates
        i += 1
    while i < numbytes:
        string += '\0'
        i += 1
    return string

"""def numFromLittleEndian(n): # n is in string format
	#debug = [n]
	n = revstr(n)
	#debug.append(n)
	s = ""
	for x in n:
		s += "%2s" % `ord(x)`
	#debug.append(s)
	#debug.append(int(s,16))
	#print debug
	return int(s,16)"""

def numFromLittleEndian(num): # num is a string
	n = 0
	power = 0
	for x in num:
		n += ord(x) * (256 ** power)
		power += 1
	return n

def readChar():
    input = sys.stdin.read(1)
    sys.stdin.readline() # Skip the rest of the line.
    return input

def readNum():
    input = sys.stdin.readline()
    input = input.strip()
    return int(input)

def readRange(low,high):
	input = readNum()
	if input in range(low,high+1):
		return input

def readReal():
    input = sys.stdin.readline()
    input = input.strip()
    return float(input)

def readLine():
    input = sys.stdin.readline()
    input = input.strip()
    return input

def readArg(*params):
	# Warning: types int, chr, str need to come last of all, if present (in that order)
	# Also, str and chr are mutually exclusive.
	input = readLine()
	for x in params:
		try:
			if x == int:
				return int(input)
			elif x == float:
				return float(input)
			elif x == chr:
				return input[0]
			elif x == str:
				return input[1]
			elif type(x) == tuple:
				if len(x) != 2: continue
  				input = int(input)
				if input in range(low,high+1):
					return input
			else:
				input = type(x)(input)
				if x == input: return x
		except:
			continue

def revstr(string):
	list = []
	for x in string:
		list.append(x)
	string = ""
	list.reverse()
	for x in list:
		string += x
	return string